/* 1list.c */

/*
 * Autor: Frantiek Dvok <valtri@students.zcu.cz>
 *
 * loha . 1:
 *  Mte dn jednosmrn zetzen uspodan seznam prvk obsahujc jako hodnoty libovoln cel sla, piem deklarace prvku seznamu bude provedena nsledujcm zpsobem:
 *
 *	typedef struct element *P_element;
 *	typedef struct element {
 *		int value;
 *		P_element next;
 *	} ELEM;
 *	P_element L=NULL;
 *
 *  Zapite rekurzivn proceduru, kter zaad nov prvek na pslun msto v seznamu.
 *
 */

#include "sysdeps.h"

#include <stddef.h>
#include <stdlib.h>
#include <stdio.h>

/*
#define malloc_inside
*/

typedef struct element *P_element;
typedef struct element {
	int value;
	P_element next;
} ELEM;

P_element L=NULL;



/* vytvo novou poloku a dopln jej hodnoty */
/* pi chyb vrac FALSE (JINAK true) */
bool create_item(P_element *item, int value, P_element next) {
	if ((*item=malloc(sizeof(ELEM)))==NULL) return FALSE;
	else {
		(*item)->value=value;
		(*item)->next=next;
		return TRUE;
	}
}


/* zaazen prvku do seznamu */
void zarad_rek(P_element *L, P_element new_item) {
	if ((*L)->value>new_item->value) {
	/* nov prvek pat ped seznam "L" */
		new_item->next=*L;
		*L=new_item;
	} else {
	/* nov prvek nkam dovnit "L" nebo za "L" */
		if (!(*L)->next) {
		/* za "L" */
			new_item->next=NULL;
			(*L)->next=new_item;
		} else zarad_rek(&(*L)->next, new_item);
	}
}


/* zaazen prvku do seznamu */
/* od 'zarad_rek2' se li tm, e tak alokace pamti pro pidvanou poloku
 * je v tto rekurzivn sti. */
bool zarad_rek2(P_element *L, int value) {
	P_element item;

	if ((*L)->value>value) {
	/* nov prvek pat ped seznam "L" */
		if (!create_item(&item, value, *L)) return FALSE;
		*L=item;
	} else {
	/* nov prvek nkam dovnit "L" nebo za "L" */
		if (!(*L)->next) {
		/* za "L" */
			if (!create_item(&item, value, NULL)) return FALSE;
			(*L)->next=item;
		} else
		/* do "L" - rekurzivn */
			return zarad_rek2(&(*L)->next, value);
	}
	return TRUE;
}

#ifndef malloc_inside

/* vol rekurzivn proceduru pro zaazen prvku */
/* Pi chyb alokace pamti nebo neplatnho parametru "L" vrac FALSE,
   jinak TRUE. */
bool zarad(P_element *L, int value) {
	P_element item;

	if (!L) return FALSE;
/* alokovn poloky seznamu */
	item=malloc(sizeof(ELEM));
	item->value=value;
/* zaazen */
	if (!*L) {
	/* jestli je seznam przdn, je to zvltn ppad */
		item->next=NULL;
		*L=item;
	} else
	/* rekurzivn zaazen */
		zarad_rek(L, item);

	/* spch */
	return TRUE;
}

#else

/* vol rekurzivn proceduru pro zaazen prvku */
/* Pi chyb alokace pamti nebo neplatnho parametru "L" vrac FALSE,
   jinak TRUE. */
bool zarad(P_element *L, int value) {
	P_element item;

	if (!L) return FALSE;
/* alokovn poloky seznamu */
	if (!create_item(&item, value, NULL)) return FALSE;
/* zaazen */
	if (!*L) {
	/* jestli je seznam przdn, je to zvltn ppad */
		*L=item;
		return TRUE;
	} else
	/* rekurzivn zaazen */
		return zarad_rek2(L, value);
}

#endif

/* uvolnn seznamu z pamti */
void freeList(P_element L) {
	P_element item;

	while (L) {
		item=L->next;
		free(L);
		L=item;
	}
}


/* vpis seznamu prvk v "L" */
void vypis(P_element L) {
	if (!L) printf("(przdn)\n");
	else {
		do {
			printf("%5d", L->value);
			L=L->next;
		} while (L);
		printf("\n");
	}
}


int main() {

	vypis(L);

	zarad(&L,10);
	vypis(L);

	zarad(&L,20);
	vypis(L);

	zarad(&L,30);
	vypis(L);

	zarad(&L,5);
	vypis(L);

	zarad(&L,25);
	vypis(L);

	freeList(L);
	return 0;
}
