/* 2bvs.c */
/*
 * Autor: Frantiek Dvok <valtri@students.zcu.cz>
 *
 * loha . 2:
 *   Mjte dn binrn vyhledvac strom deklarovan nsledujcm zpsobem:
 *
 *	typedef struct element *P_node;
 *	typedef struct element {
 *		int value;
 *		P_node left_son, right_son;
 *	} NODE;
 *	P_node bvs = NULL;
 *
 *   Zapite proceduru, kter vype obsah BVS pootoen tak, aby nejlevj list stromu byl v prav polovin prv dky a koen stromu na zatku stedn sti obrazovky:
 *     a) s vyuitm rekurze
 *     b) bez pouit rekurze
 *
 */

#include "sysdeps.h"

#include <stddef.h>
#include <stdlib.h>
#include <stdio.h>
#include <malloc.h>
#include <setjmp.h>

#include "2list.h"

/* trasovac zprvy o zsobnku (pro vpis stromu) */
/*#define traceStack*/

/*#define medSkip "\t"*/
#define medSkip "  "
/* poznmka:
 *   jsou terminly, kter znak tabultoru nepodporuj, lep je
 *   pouit mezer
 */

typedef struct element *P_node;
typedef struct element {
	int value;
	P_node left_son, right_son;
} NODE;

P_node bvs = NULL;



/* vytvoen uzlu stromu: alokace + piazen hodnot */
/* Pi nedostatku pamti vrac FALSE. */
bool create_node(P_node *node, int value, P_node left, P_node right) {
	if (!(*node=malloc(sizeof(NODE)))) return FALSE;
	(*node)->value=value;
	(*node)->left_son=left;
	(*node)->right_son=right;
	return TRUE;
}


/* uvolnn stromu z pamti (rekurzivn) */
void tree_free(P_node tree) {
	if (tree) {
		tree_free(tree->left_son);
		tree_free(tree->right_son);
		free(tree);
	}
}


/* zaazen prvku do stromu */
void tree_put(P_node *tree, P_node new_node) {
	P_node node, son;
	int value;

	if (!*tree)
	/* przdn strom */
		*tree=new_node;
	else {
	/* nalezen msta, kam nov uzel umstit ==> "node" */
		value=new_node->value;
		son=*tree;
		do {
			node=son;
			if (node->value>value) {
			/* nov poloka doleva */
				son=node->left_son;
				if (!son) node->left_son=new_node;
			} else {
			/* nov poloka doprava */
				son=node->right_son;
				if (!son) node->right_son=new_node;
			}
		} while (son);
	}
}


/* vytvoen novho uzlu stromu a jeho zaazen (pi chyb vrt FALSE) */
bool zarad(P_node *tree, int value) {
	P_node new_node;

	/* alokace pamti pro uzel s kontrolou chyby */
	if (!create_node(&new_node, value, NULL, NULL)) return FALSE;

	/* zaazen vytvoenho uzlu do stromu */
	tree_put(tree, new_node);
	/* spch */
	return TRUE;
}


/* pomocn procedura pro vypsn uzlu */
void print_node(P_node node, int level) {
	int i;

	for (i=0; i<level; i++) printf(medSkip);
	printf("%d\n", node->value);
}


/* rekurzivn procedura pro vpis stromu */
/* vypisuje podle zadn: naped lev, pak prav;
 * prakticky bych dlal vpis naopak */
void print_tree_rek0(P_node tree, int level) {

	if (tree->left_son) print_tree_rek0(tree->left_son, level+1);
	print_node(tree, level);
	if (tree->right_son) print_tree_rek0(tree->right_son, level+1);
}


/* vype strom */
/* Jedn se o prvn vyvoln rekurzivn procedury. */
void print_tree_rek(P_node tree) {
	if (!tree)
		printf("(przdn strom)\n");
	else
		print_tree_rek0(tree, 0);
}


/* vlo do seznamu jako do zsobnku uzel 'node' */
bool push_node(list_p *stack, P_node node, int *level) {
	if (!list_push(stack, node)) return FALSE;
#ifdef traceStack
	fprintf(stderr, "push(%d) ", node->value);
#endif
	(*level)++;
	return TRUE;
}

/* vbr uzlu 'node' ze zsobnku */
void pop_node(list_p *stack, P_node *node, int *level) {
	list_pop(stack, (void **)node);
#ifdef traceStack
	if (node) fprintf(stderr, "pop(%d) ", (*node)->value);
	else fprintf(stderr, "pop(-) ");
#endif
	(*level)--;
}


/* nerekurzivn vpis stromu */
/* Dsledn (a zbyten) kontrola chyb pi alokaci pamti.
 * S knihovnou 'setjmp.h' to ale algoritmus nezamluje. */
void print_tree(P_node tree) {
	jmp_buf errorLBL;       /* errorLBL - oeten vyjmek */
	list_p stack=NULL; /* zsobnk uzl */
	P_node node, son;
	int level=0;            /* rove vnoen ve stromu */

	if (setjmp(errorLBL)) {
	/* pi chyb vypsn zprvy a konec */
		printf("Nedostatek pamti pro vypsn stromu.\n");
		list_free(stack);
		return;
	}

	/* od koene */
	node=tree;
	while (node!=NULL) {
		/* jestlie existuje lev syn, pak se do pono */
		if (node->left_son!=NULL) {
			if (!push_node(&stack, node, &level)) longjmp(errorLBL, 1);
			node=node->left_son;
		} else {
			/* vypsn hodnoty uzlu */
			print_node(node, level);
			/* jestlie existuje prav syn, pak ponoen doprava */
			if (node->right_son) {
				if (!push_node(&stack, node, &level)) longjmp(errorLBL, 1);
				node=node->right_son;
			} else {
			/* jinak nvrat */
				do {
					son=node;
					pop_node(&stack, &node, &level);
					/* jestlie byl nvrat zleva, pak vypsn hodnoty uzlu */
					if (node)
						if (node->left_son==son) print_node(node, level);
				/* vrac se, dokud je nvrat zprava (nebo zleva, kdy zprava nelo) */
				} while (node && (node->right_son==son || (node->right_son==NULL && node->left_son==son)));
				/* po nvratu zleva a pi existujcm pravm podstromu se do pono */
				if (node) {
					if (node->left_son==son && node->right_son!=NULL) {
					/* jestlie se m dle po nvratu ponoit, pak jedin vpravo */
						if (!push_node(&stack, node, &level)) longjmp(errorLBL, 1);
						node=node->right_son;
					}
				}
			}
		}
	}
	/* hotovo, 'stack' je przdn */
}


int main() {
	int i;

	print_tree_rek(bvs);
	printf("\n");

	for (i=0; i<11; i++) {
		if (!zarad(&bvs, rand() % 50)) {
			fprintf(stderr, "Chyba.\n");
			tree_free(bvs);
			return 1;
		}
	}

	printf("------------------------------------------------\n");
	print_tree_rek(bvs);
	printf("------------------------------------------------\n");
	print_tree(bvs);
	printf("------------------------------------------------\n");

	tree_free(bvs);

	return 0;
}
