/* 2list.inc */

#include "sysdeps.h"

#include <malloc.h>

typedef struct list_item_t *list_p;
typedef struct list_item_t {
	void *data;
	list_p next;
} list_t;


/* vytvo novou poloku a dopln jej hodnoty */
/* pi chyb vrac FALSE (JINAK true) */
bool list_create_item(list_p *item, void *data, list_p next) {
	if ((*item=malloc(sizeof(list_t)))==NULL) return FALSE;
	else {
		(*item)->data=data;
		(*item)->next=next;
		return TRUE;
	}
}



/* ---- realizace FIFO ---- */


/* vytvoen nov poloky a jej vloen na zatek seznamu */
bool list_push(list_p *list, void *data) {
	list_p item;

	if (!list_create_item(&item, data, *list)) return FALSE;
	*list=item;
	return TRUE;
}


/* odebrn prvn poloky ze seznamu, jestlie je seznam przdn,
   vrac se FALSE */
bool list_pop(list_p *list, void **data) {
	list_p item;

	if (!*list) {
	/* przdn seznam ==> vrt NULL */
		*data=NULL;
		return FALSE;
	} else {
		/* zjitn dat */
		*data=(*list)->data;
		/* odstrann ze seznamu */
		item=*list;
		*list=(*list)->next;
		free(item);
		return TRUE;
	}
}


/* uvolnn seznamu z pamti */
void list_free(list_p L) {
	list_p item;

	while (L) {
		item=L->next;
		free(L);
		L=item;
	}
}


